"{ Package: 'jv:calipel/s/tests' }"

BenchmarkInstanceTestsA subclass:#BenchmarkInstanceTestsB
	instanceVariableNames:'param3 param4 param5'
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Tests'
!


!BenchmarkInstanceTestsB methodsFor:'parameters'!

param1:anInteger
    <parameter: #param1 type: #Integer default: 5678>

    param1 := anInteger.

    "Created: / 09-03-2014 / 22:46:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

param3
    ^ param3
!

param3:aBoolean
    <parameter: #param3 type: #Boolean default: false>
    param3 := aBoolean.

    "Modified: / 30-07-2013 / 23:09:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

param4
    ^ param4
!

param4:anObject
    <parameter: #param4 type: #Float>
    param4 := anObject.

    "Modified: / 30-07-2013 / 23:41:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

param5
    ^ param5
!

param5:something
    <parameter: #param5 type: #Symbol default: #uniform values: #(#sequential #uniform #normal)>
    param5 := something.

    "Modified: / 01-08-2013 / 23:40:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsB methodsFor:'tests'!

test_03a

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new
        at: #'param4' put: '0.0';
        yourself).

    "parem1 is overridden here..."
    self assert: param1 == 5678

    "Created: / 09-03-2014 / 22:46:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_05a

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new
                        at: #'param4' put: '0.0';
                        at: #'param1' put: '9876';
                        at: #'BenchmarkInstanceTestsB#param1' put: '1234'; yourself).

    self assert: param1 == 1234

    "Created: / 30-07-2013 / 23:14:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_05b

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new
                        at: #'param4' put: '0.0';
                        at: #'param1' put: '9876';
                        at: #'BenchmarkInstanceTestsA#param1' put: '1234'; yourself).

    self assert: param1 == 9876

    "Created: / 30-07-2013 / 23:14:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_05c

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new
                        at: #'param4' put: '0.0';
                        at: #'param1' put: '9876';
                        at: #'BenchmarkInstanceTestsA#param1' put: '1234';
                        at: #'BenchmarkInstanceTestsB#param1' put: '5555';
                        yourself).

    self assert: param1 == 5555

    "Created: / 30-07-2013 / 23:15:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_06

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    "param4 value's missing..."
    self should:[
        r := b run: BenchmarkResult new with: (Dictionary new
                            yourself).
    ] raise: BenchmarkParameterError.

    "Created: / 30-07-2013 / 23:42:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 10-03-2014 / 10:20:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_07

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b
            run: BenchmarkResult new
            with: (Dictionary new
                    at: 'param4' put:'1.0';
                    at: 'param5' put:'sequential,uniform';
                    yourself).

    self assert: r outcomes size == 2.

    "Created: / 01-08-2013 / 23:41:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsB class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

