# == Schema Information
#
# Table name: benchmark_infos
#
#  id                 :integer          not null, primary key
#  benchmark_class    :string(255)
#  benchmark_selector :string(255)
#  description        :text
#  created_at         :datetime
#  updated_at         :datetime
#  name               :string(255)
#

class BenchmarkInfo < ActiveRecord::Base

  has_many :benchmark_results, dependent: :destroy, inverse_of: :benchmark_info

  validates_presence_of :name, :benchmark_class, :benchmark_selector

  def BenchmarkInfo.from_json(data)
      bench_info = BenchmarkInfo.where(name: data["name"]).first
      bench_info = BenchmarkInfo.create!(
          name:               data["name"],
          benchmark_class:    data["class"],
          benchmark_selector: data["selector"],
          description:        data["description"]
      ) unless bench_info
      return bench_info

  end
end
